#!/bin/sh

# detectTMSM.sh
# SupportTool
#
# Created by Andy Tzeng on 2009/7/20.
# Copyright 2009 Trend Micro Incorporated. All rights reserved.

BDL_ID_TMSM_MAINUI="com.trendmicro.tmsm.MainUI"
BDL_ID_TMSM_UIMGMT="com.trendmicro.tmsm.UIMgmt"

TM_LIBRARY_PATH="/Library/Application Support/TrendMicro"
APPLICATIONS_PATH="/Applications"

ITIS_APP_NAME="iTIS.app"
DEFAULT_UIMGMT_PATH="$TM_LIBRARY_PATH/TmccMac/UIMgmt.app"
DEFAULT_MAINUI_PATH="$APPLICATIONS_PATH/$ITIS_APP_NAME"
DEFAULT_INFO_PLIST="/Contents/Info.plist"

MDFIND=/usr/bin/mdfind
MDLS=/usr/bin/mdls
HEAD=/usr/bin/head
DEFAULTS=/usr/bin/defaults

get_valueByKey()
{
    kMDFile="$1"
    kMDItem="$2"
    if [ ! -e "$kMDFile" ] || [ -z "$kMDItem" ]; then
        kMDItemValue=""
        return 1;
    fi
    if [ -d "$kMDFile" -a ! -z "echo $kMDFile | grep '\.app\$'" ]; then
        kMDItemValue=$($MDLS -name $kMDItem "$kMDFile" | grep $kMDItem | sed "s/$kMDItem = \"\([^\"]*\)\"/\1/")
    elif [ -f "$kMDFile" -a ! -z "echo $kMDFile | grep '\.plist\$'" ]; then
        kMDItemValue=$($DEFAULTS read "${kMDFile%.plist}" "$kMDItem")
    fi
}

chk_tmsm_and_itis10_exist()
{
    chk_ret=0;
    UIMGMT_APP=$($MDFIND -onlyin "$TM_LIBRARY_PATH" "kMDItemCFBundleIdentifier = '$BDL_ID_TMSM_UIMGMT'")

    if [ -z "$UIMGMT_APP" ]; then
        UIMGMT_APP="$DEFAULT_UIMGMT_PATH"
        get_valueByKey "${UIMGMT_APP}$DEFAULT_INFO_PLIST" CFBundleIdentifier
        if [ -z "$kMDItemValue" ]; then
            get_valueByKey "$UIMGMT_APP" kMDItemCFBundleIdentifier
        fi

        if [ "$kMDItemValue" != "$BDL_ID_TMSM_UIMGMT" ]; then
            return $chk_ret
        fi
    fi

    # check tmsm whether installed
    if [ -d "$UIMGMT_APP" ]; then
        chk_ret=1;

        # check itis whether installed (because that the BID of iTIS-1.0 is the same as tmsm-sa)
        CUR_ITIS_APP_PATH=$($MDFIND -onlyin "$APPLICATIONS_PATH" "kMDItemCFBundleIdentifier = '$BDL_ID_TMSM_MAINUI'" | $HEAD -n 1)
        [ x"$CUR_ITIS_APP_PATH" = "x" ] && CUR_ITIS_APP_PATH="$DEFAULT_MAINUI_PATH"
    
        if [ -d $CUR_ITIS_APP_PATH ]; then
            get_valueByKey "$CUR_ITIS_APP_PATH" kMDItemFSName
            CUR_ITIS_APP_NAME=$kMDItemValue
            if [ "$CUR_ITIS_APP_NAME" = "$ITIS_APP_NAME" ]; then
                chk_ret=2;
            fi
        fi
    fi
    # return 1: tmsm, 2: iTIS 1.0
    return $chk_ret
}

RET=0
chk_tmsm_and_itis10_exist;
if [ $? -eq 1 ]; then
    RET=1
fi
exit $RET
