#!/bin/bash

# startServices.sh
# SupportTool
#
# Created by Andy Tzeng on 2009/5/17.
#			 Jie Wu		on 2012/3/8
# Copyright 2009 Trend Micro Incorporated. All rights reserved.

TM_LIBRARY_PATH="/Library/Application Support/TrendMicro"

OS_VERSION=$(sw_vers | grep 'ProductVersion:' | egrep -o '[0-9]*(\.[0-9]*){1,2}')
OS_MAJOR_VERSION=$(echo $OS_VERSION | cut -f 1 -d . -)
OS_MINOR_VERSION=$(echo $OS_VERSION | cut -f 2 -d . -)

LaunchdDir="/Library/LaunchDaemons"
# start iCoreService

coreServices=(
    "com.trendmicro.icore.main"
    "com.trendmicro.icore.av"
    "com.trendmicro.icore.wp"
    "com.trendmicro.icore.misc"
    "com.trendmicro.itis.fbdaemon"
    "com.trendmicro.AFM.HelperTool"
)

# stop iCoreservice
startiCore()
{
    #/sbin/SystemStarter start iCoreService > /dev/null
    "$TM_LIBRARY_PATH"/TmccMac/iCoreMgr -s start icore
}

startiTisService()
{
    for item in ${coreServices[@]}; do
        svc=`launchctl list | grep $item`
        if [ -z "$svc" ]; then
            launchctl load -w "${LaunchdDir}/${item}.plist"
        fi
    done
}

step1()
{
    startiCore
    startiTisService
}

step2()
{
    ICORE=$(ps A -o command | grep '^\(\/Library\/.*\/TmccMac/iCoreService\)')
    if [ -z "$ICORE" ]; then
        "$TM_LIBRARY_PATH"/TmccMac/iCoreMgr -s start icore
    fi
}

step3()
{
    os_ver=$(sw_vers -productVersion | tr -d ".")
    touch "/Library/Application Support/TrendMicro/TMAFM/UIMgmt.lock"
    
    user=$(stat -f "%Su" /dev/console)
    uid=$(id -u $user)
    launchctl asuser $uid launchctl load /Library/LaunchAgents/com.trendmicro.itis.uimgmt.agent.plist

    sleep 5
}


user=`whoami`
if [ $user != "root" ]; then
	echo "Error! stop with user '$user'. Make sure you are 'root'!"
else
	step1;
	step2;
	step3;
fi
