#!/bin/bash

# uninstallServices.sh
# SupportTool

ENABLE_LOG=1

DBGLOG=/dev/null
if [ $ENABLE_LOG -eq 1 -o -f /tmp/itisuninstall_dbg.flag ]; then
DBGLOG=/tmp/itisuninstall.log
fi
/bin/date > $DBGLOG
export >> $DBGLOG

OS_VERSION=$(sw_vers | grep 'ProductVersion:' | egrep -o '[0-9]*(\.[0-9]*){1,2}')
OS_MAJOR_VERSION=$(echo $OS_VERSION | cut -f 1 -d . -)
OS_MINOR_VERSION=$(echo $OS_VERSION | cut -f 2 -d . -)
echo "OS version: $OS_VERSION" >> $DBGLOG
UNINSTALL_LOCK=/var/tmp/itisuninstall.lock
TM_DIR="/Library/Application Support/TrendMicro"
COMMONLIB_DIR="common/lib"
APP_DIR="TmccMac"
MAINUI_NAME="iTIS"
APPLICATION_FOLDER="TrendMicro.localized"

MAINSERVICE_PLIST="/Library/StartupItems/iCoreService/StartupParameters.plist"
MAINSERVICE_STARTER="/Library/StartupItems/iCoreService/iCoreService"

PRODAPP_PATH="${TM_DIR}/${APP_DIR}"
LOGINMGRAPP="/Library/Application Support/TrendMicro/TmccMac/TmLoginMgr.app"
LOGINMGR="${PRODAPP_PATH}/TmLoginMgr.app/Contents/MacOS/TmLoginMgr"

UIMGMT_JOB="com.trendmicro.itis.uimgmt.agent"
UNINSTALLER_JOB="com.trendmicro.itis.uninstaller"

DCA_JOB="com.trendmicro.itis.dca"
DCA_PLIST="/Library/LaunchAgents/com.trendmicro.itis.dca.plist"

DMR_JOB="com.trendmicro.itis.dmr"
DMR_PLIST="/Library/LaunchAgents/com.trendmicro.itis.dmr.plist"

GAAGENT_JOB="com.trendmicro.itis.gaagent"
GAAGENT_PLIST="/Library/LaunchAgents/com.trendmicro.itis.gaagent.plist"

PUM_JOB="com.trendmicro.TMPUMModule"
PUM_PLIST="/Library/LaunchAgents/com.trendmicro.TMPUMModule.plist"


PYRATING_SERVER_JOB="com.trendmicro.itis.pyratingserver"
PYRATING_SERVER_TARGET="/Library/LaunchDaemons/com.trendmicro.itis.pyratingserver.plist"
PYRATING_SERVER_PLIST="/Library/Application Support/TrendMicro/TmToolbar/com.trendmicro.itis.pyratingserver.plist"

# application files
APP_RECEIPTS=""
APP_RECEIPTS="$APP_RECEIPTS tmccapp"
APP_RECEIPTS="$APP_RECEIPTS tmccapp_update"
APP_RECEIPTS="$APP_RECEIPTS icorepackage"
APP_RECEIPTS="$APP_RECEIPTS icoreconfiguration"
APP_RECEIPTS="$APP_RECEIPTS itispackages"

# log files
VAR_LOG_FOLDER="/var/log/TrendMicro"
VAR_LOG_FILES="DCA"
VAR_LOG_FILES="${VAR_LOG_FILES} DMR"
VAR_LOG_FILES="${VAR_LOG_FILES} GAAgent"
VAR_LOG_FILES="${VAR_LOG_FILES} TMPUMModule"
VAR_LOG_FILES="${VAR_LOG_FILES} TmccCore"
VAR_LOG_FILES="${VAR_LOG_FILES} onUiMgmtLoaded.log"
VAR_LOG_FILES="${VAR_LOG_FILES} TmccAUPkg.log"
VAR_LOG_FILES="${VAR_LOG_FILES} iTISPlugin.log"
VAR_LOG_FILES="${VAR_LOG_FILES} toolbar_installer.log"
VAR_LOG_FILES="${VAR_LOG_FILES} SystemChecker.log"
VAR_LOG_FILES="${VAR_LOG_FILES} migration.log"
VAR_LOG_FILES="${VAR_LOG_FILES} AUSilentInstaller.log"
VAR_LOG_FILES="${VAR_LOG_FILES} AutoUpgradeDownload.log"
VAR_LOG_FILES="${VAR_LOG_FILES} iTISPatch"
VAR_LOG_FILES="${VAR_LOG_FILES} iTISupdate.log"
VAR_LOG_FILES="${VAR_LOG_FILES} iTISCorridor.log"
VAR_LOG_FILES="${VAR_LOG_FILES} AirSupportDownloader.log"
VAR_LOG_FILES="${VAR_LOG_FILES} AirSupport"
VAR_LOG_FILES="${VAR_LOG_FILES} TmUtyPPi.log"
VAR_LOG_FILES="${VAR_LOG_FILES} SupportTool"
VAR_LOG_FILES="${VAR_LOG_FILES} .DS_Store"
VAR_LOG_FILES="${VAR_LOG_FILES} AFMHelperTool.log"


USER_LOG_FILES="/Library/Logs/TrendMicro"
UI_FILES="$APP_DIR/UIMgmt.app"

FWK_DIRS="/Library/Frameworks/iCoreClient.framework"
FWK_DIRS="${FWK_DIRS} /Library/Frameworks/iCoreClientPb.framework"
FWK_DIRS="${FWK_DIRS} /Library/Frameworks/TMAppCommon.framework"
FWK_DIRS="${FWK_DIRS} /Library/Frameworks/TMAppCore.framework"
FWK_DIRS="${FWK_DIRS} /Library/Frameworks/TMGUIUtil.framework"
FWK_DIRS="${FWK_DIRS} /Library/Frameworks/TMSSClient.framework"
FWK_DIRS="${FWK_DIRS} /Library/Frameworks/TMWeb.framework"
FWK_DIRS="${FWK_DIRS} /Library/Frameworks/TMSSDA.framework"

UIAPP_FILES=""
UIAPP_FILES="${UIAPP_FILES} iTIS.app"
UIAPP_FILES="${UIAPP_FILES} UninstallerLauncher.app"
UIAPP_FILES="${UIAPP_FILES} SupportTool.app"
UIAPP_FILES="${UIAPP_FILES} AirSupportDownloader.app"
UIAPP_FILES="${UIAPP_FILES} AFMAgent.app"


UNINSTALLER_PLIST=""
UNINSTALLER_PLIST="${UNINSTALLER_PLIST} /Library/LaunchAgents/com.trendmicro.itis.uninstaller.plist"

UIAPP_CONF_FILES=""
UIAPP_CONF_FILES="${UIAPP_CONF_FILES} /Library/Preferences/com.trendmicro.iTIS.UIMgmt.plist"
UIAPP_CONF_FILES="${UIAPP_CONF_FILES} /Library/Preferences/com.trendmicro.iTIS.MainUI.plist"
UIAPP_CONF_FILES="${UIAPP_CONF_FILES} /Library/Preferences/com.trendmicro.AFMMainUI.plist"
UIAPP_CONF_FILES="${UIAPP_CONF_FILES} /Library/Preferences/com.trendmicro.iTIS.SupportTool.plist"
UIAPP_CONF_FILES="${UIAPP_CONF_FILES} /Library/Preferences/com.trendmicro.DMRManager.plist"
UIAPP_CONF_FILES="${UIAPP_CONF_FILES} /Library/Preferences/com.trendmicro.iTIS.Uninstaller.plist"
UIAPP_CONF_FILES="${UIAPP_CONF_FILES} /Library/Preferences/com.trendmicro.AirSupport.V1.plist"


WEB_KIT_CACHES=""
WEB_KIT_CACHES="${WEB_KIT_CACHES} iTIS com.trendmicro.iTIS.MainUI"
WEB_KIT_CACHES="${WEB_KIT_CACHES} UIMgmt com.trendmicro.iTIS.UIMgmt"
WEB_KIT_CACHES="${WEB_KIT_CACHES} SupportTool com.trendmicro.iTIS.SupportTool"

# core module files
SYSCORE_FILES=""
SYSCORE_FILES="${SYSCORE_FILES} $MAINSERVICE_PLIST"
SYSCORE_FILES="${SYSCORE_FILES} $MAINSERVICE_STARTER"
SYSCORE_FILES="${SYSCORE_FILES} /System/Library/TrendMicro/KERedirect.kext"
SYSCORE_FILES="${SYSCORE_FILES} /System/Library/TrendMicro/tmccfshook-10.4.kext"
SYSCORE_FILES="${SYSCORE_FILES} /System/Library/TrendMicro/tmccfshook-10.5.kext"

CORE_FILES=""
# itis 3.5 core files
CORE_FILES="${CORE_FILES} common"
CORE_FILES="${CORE_FILES} DCA"
CORE_FILES="${CORE_FILES} DMR"
CORE_FILES="${CORE_FILES} GAAgent"
CORE_FILES="${CORE_FILES} PUM"
CORE_FILES="${CORE_FILES} Plug-in"
CORE_FILES="${CORE_FILES} TMSS"
CORE_FILES="${CORE_FILES} TmToolbar"
CORE_FILES="${CORE_FILES} TmccMac"
CORE_FILES="${CORE_FILES} TmccUpdate"
CORE_FILES="${CORE_FILES} TmccUpgrade"
CORE_FILES="${CORE_FILES} kext"
CORE_FILES="${CORE_FILES} uninstall"
# itis 3.0 core files which are removed in 3.5
CORE_FILES="${CORE_FILES} TMFBDaemon"
CORE_FILES="${CORE_FILES} SafariToolbar"
CORE_FILES="${CORE_FILES} TMAFM"


CHKDAT=/var/tmp/tmccinstcheck.dat

FINDER_SYNC_FILE="/Library/Application Support/TrendMicro/TMAFM/AFMMainUI.app/Contents/PlugIns/AFMFinderSync.appex"

usage()
{
	echo "Usage: $0 [status|start|stop]" >&2
	exit 1;
}

# Definition
CORE_PKG_BUNDLE_ID_PREFIX="com.trendmicro.icore."
ITIS_PKG_BUNDLE_ID_PREFIX="com.trendmicro.iTIS.installer."
ITIS10_PKG_BUNDLE_ID_PREFIX1="com.trendmicro.tmcc."
ITIS10_PKG_BUNDLE_ID_PREFIX2="com.trendmicro.tmss."

DEFAULT_INFO_PLIST="/Contents/Info.plist"

TMP_ITIS_INFO_DIR="/private/tmp/TrendMicro/iTIS"
TMP_UNINSTALL_INFO_PLIST="${TMP_ITIS_INFO_DIR}/iTISUninstallResultInfo.plist"

PLIST_BUDDY="/usr/libexec/PlistBuddy"

MDFIND=/usr/bin/mdfind
MDLS=/usr/bin/mdls
HEAD=/usr/bin/head
DEFAULTS=/usr/bin/defaults

ITIS10_CORRIDOR_FILE="/Library/Application Support/TrendMicro/Plug-in/Corridor.framework/Resources/Corridor.plist"
ITIS11_CORRIDOR_FILE="/Library/Application Support/TrendMicro/TMAFM/Corridor.framework/Versions/A/Resources/Corridor.plist"

ITIS10_INFO_FILE="/Library/Application Support/TrendMicro/TmccMac/UIMgmt.app/Contents/Info.plist"
ITIS11_INFO_FILE="/Library/Application Support/TrendMicro/TMAFM/AFMMainUI.app/Contents/Info.plist"

BACKUP_FOLDER="/Users/Shared/TrendMicro/Backup"

get_cur_timestamp() {
	cur_sec_and_ns=`date '+%s-%N'`
	cur_sec=${cur_sec_and_ns%-*}
	cur_ns=${cur_sec_and_ns##*-}
	cur_timestamp=$((cur_sec*1000+cur_ns/1000000))

	echo "cur_timestamp: $cur_timestamp" >> $DBGLOG

	return "$cur_timestamp"
}

backup_corridor() {
	echo "Backup Corridor.plist to $BACKUP_FOLDER" >> $DBGLOG

	mkdir -p "$BACKUP_FOLDER"
    chmod -R 700 "$BACKUP_FOLDER" 
    chflags hidden "$BACKUP_FOLDER"

	if [ -e "$ITIS10_CORRIDOR_FILE" ] ; then
		ITIS10_VERSION=''
		if [ -e "$ITIS10_INFO_FILE" ]; then
			ITIS10_VERSION="$($PLIST_BUDDY -c 'Print :CFBundleShortVersionString' "$ITIS10_INFO_FILE")"
		fi

		echo "iTIS10 version: $ITIS10_VERSION" >> $DBGLOG

		get_cur_timestamp

		cp -f "$ITIS10_CORRIDOR_FILE" "$BACKUP_FOLDER/Corridor-$ITIS10_VERSION-$cur_timestamp-uninstall"
		echo "Backup $ITIS10_CORRIDOR_FILE to $BACKUP_FOLDER/Corridor-$ITIS10_VERSION-$cur_timestamp-uninstall" >> $DBGLOG
	fi

	if [ -e "$ITIS11_CORRIDOR_FILE" ] ; then
		ITIS11_VERSION=''
		if [ -e "$ITIS11_INFO_FILE" ]; then
			ITIS11_VERSION="$($PLIST_BUDDY -c 'Print :CFBundleShortVersionString' "$ITIS11_INFO_FILE")"
		fi

		echo "iTIS11 version: $ITIS11_VERSION" >> $DBGLOG

		get_cur_timestamp

		cp -f "$ITIS11_CORRIDOR_FILE" "$BACKUP_FOLDER/Corridor-$ITIS11_VERSION-$cur_timestamp-uninstall"
		echo "Backup $ITIS11_CORRIDOR_FILE to $BACKUP_FOLDER/Corridor-$ITIS11_VERSION-$cur_timestamp-uninstall" >> $DBGLOG
	fi

	echo "Backup Corridor.plist end" >> $DBGLOG
}

initpercent()
{
	PERCENT=$1
	echo "[$PERCENT%]" ;
	$PLIST_BUDDY -c "Delete :UninstallPercentage" "$TMP_UNINSTALL_INFO_PLIST"
	$PLIST_BUDDY -c "Add :UninstallPercentage integer $1" "$TMP_UNINSTALL_INFO_PLIST"
	sleep 1
}

tagpercent()
{
	PERCENT=$1
	echo "[$PERCENT%]" ;
	$PLIST_BUDDY -c "Set :UninstallPercentage $1" "$TMP_UNINSTALL_INFO_PLIST"
	sleep 1
}

get_valueByKey()
{
	kMDFile="$1"
	kMDItem="$2"
	if [ ! -e "$kMDFile" ] || [ -z "$kMDItem" ]; then
		kMDItemValue=""
		return 1;
	fi
	if [ -d "$kMDFile" -a ! -z "echo $kMDFile | grep '\.app\$'" ]; then
		kMDItemValue=$($MDLS -name $kMDItem "$kMDFile" | grep $kMDItem | sed "s/$kMDItem = \"\([^\"]*\)\"/\1/")
	elif [ -f "$kMDFile" -a ! -z "echo $kMDFile | grep '\.plist\$'" ]; then
		kMDItemValue=$($DEFAULTS read "${kMDFile%.plist}" "$kMDItem")
	fi
}

lock()
{
	UNINST_PID="$$"
	if ! /usr/bin/shlock -f $UNINSTALL_LOCK -p "$UNINST_PID" ; then
		exit 1
	fi
}

unlock()
{
	rm -f $UNINSTALL_LOCK
}

trap_hook()
{
	unlock
}

app_is_empty()
{
	#if [ "`ls -A "$1"/*.app`" = "" ]; then
	if [ "`find "$1" -name "*.app"`" = "" ]; then
		return 0
	else
		return 1
	fi
}

dir_is_empty()
{
	if [ "`ls -A "$1"`" = "" ]; then
		return 0
	else
		return 1
	fi
}

file_is_iTISPlugin()
{
	if [ "`echo $i | grep -- 'iTISPlugin\.log.*tar\.z'`" = "" ]; then
		return 0
	else
		return 1
	fi
}


remove_file()
{
	rm $1 "$2" 2>&1 >> $DBGLOG
}

remove_receipt ()
{
	pkgutil --forget $1 2> $DBGLOG
}

remove_receipt_specified_prefix ()
{
	if [ -z "$1" ]; then
		return
	fi

	local LIST="$(pkgutil --pkgs="$1" 2>> $DBGLOG)"
	for i in ${LIST} ; do
		remove_receipt $i
	done
}

uninstall_itis10()
{
	TMLOGINMGR_PLIST="/Library/LaunchAgents/com.trendmicro.tmcc.loginmgr.plist"

	killall "$MAINUI_NAME" 2>/dev/null >/dev/null
	echo "terminating $MAINUI_NAME, rc=$?" 2>&1 >> $DBGLOG
	RUSER="$USER"
	if [ ! -z "$SUDO_USER" ]; then
		RUSER="$SUDO_USER"
	fi
	if [ -f "$TMLOGINMGR_PLIST" ]; then
		sudo -u "$RUSER" launchctl unload "$TMLOGINMGR_PLIST" 2>/dev/null
		echo "unload $TMLOGINMGR_PLIST, rc=$?" 2>&1 >> $DBGLOG
	else
		sudo -u "$RUSER" launchctl unload "com.trendmicro.tmcc.loginmgr" 2>/dev/null
		echo "don't need to unload $TMLOGINMGR_PLIST" 2>&1 >> $DBGLOG
	fi

	# remove global service information
	"$LOGINMGR" -u 2>&1 >>$DBGLOG
	killall TmLoginMgr UIMgmt 2>/dev/null >/dev/null
	echo "terminating UIMgmt, rc=$?" 2>&1 >>$DBGLOG
	# wait the TmLoginMr to unload from launchd
	sleep 2

	# Remove APPs
	#remove_file -Rf "$TM_DIR"
	remove_file -Rf "$TMLOGINMGR_PLIST"

	CONF_FILES="/Library/Preferences/com.trendmicro.tmcc.UIMgmt.plist"
	CONF_FILES="${CONF_FILES} /Library/Preferences/com.trendmicro.tmcc.MainUI.plist"
	CONF_FILES="${CONF_FILES} /Library/Preferences/com.trendmicro.tmsm.UIMgmt.plist"
	CONF_FILES="${CONF_FILES} /Library/Preferences/com.trendmicro.tmsm.MainUI.plist"

	USERS_DIR=/Users
	for UDIR in ${USERS_DIR}/* ; do
		TARGET_HOME="${UDIR}"
		for file in $CONF_FILES; do
			remove_file -Rf "$TARGET_HOME/$file"
		done
	done

	remove_file -Rf "/Library/Frameworks/TMCCGUIUtil.framework"
	remove_file -Rf "/Applications/${MAINUI_NAME}.app"

	RECEIPTS="tmccguiutil tmccmgmt tmccuiutils"
	RECEIPTS="$RECEIPTS trendMicroCommonClientForMac uimgmt"
	RECEIPTS="$RECEIPTS mainuiapp comtrendmicrotmccuimgmt"
	RECEIPTS="$RECEIPTS tmccuninstall tmcccore"
	RECEIPTS="$RECEIPTS tmccapp tmccapplib tmccutils"
	RECEIPTS="$RECEIPTS trendMicroSmartSurfingPostflight"

	for i in ${RECEIPTS} ; do
		remove_file -Rf "/Library/Receipts/$i.pkg"
	done
	remove_receipt_specified_prefix "${ITIS10_PKG_BUNDLE_ID_PREFIX1}*"
	remove_receipt_specified_prefix "${ITIS10_PKG_BUNDLE_ID_PREFIX2}*"

	remove_file -Rf /System/Library/TrendMicro
	#remove_file -Rf "${TM_DIR}"
	return 0
}

unload_app()
{
	killall "$MAINUI_NAME" 2>/dev/null >/dev/null
	echo "terminating $MAINUI_NAME, rc=$?" 2>&1 >> $DBGLOG

	# remove global service information
	"$LOGINMGR" -u 2>&1 >>$DBGLOG

	killall TmLoginMgr 2>/dev/null >/dev/null
	echo "terminating TmLoginMgr, rc=$?" 2>&1 >>$DBGLOG

	#Remove UIMgmt lock
	rm "/Library/Application Support/TrendMicro/common/var/UIMgmt.lock"
	rm "/Library/Application Support/TrendMicro/TMAFM/UIMgmt.lock"

	for u in $(users); do
        uid=$(id -u $u)
		launchctl asuser $uid launchctl unload "$UIMGMT_JOB"
		launchctl asuser $uid launchctl unload "$UNINSTALLER_JOB"
	done

	sleep 1

	echo "terminating UIMgmt, rc=$?" 2>&1 >>$DBGLOG
	killall UIMgmt AFMMainUI 2>/dev/null >/dev/null
	killall AFMAgent 2>/dev/null >/dev/null

	echo "stop finder sync" >>$DBGLOG
	/usr/bin/pluginkit -e ignore -i com.trendmicro.AFMMainUI.AFMFinderSync 2>&1 >>$DBGLOG
    /usr/bin/pluginkit -r "${FINDER_SYNC_FILE}" 2>&1 >>$DBGLOG

	return 0
}

uninstall_icore_app() 
{
	version=`sw_vers -productVersion`
	echo "current masOS version = $version" 2>&1 >>$DBGLOG
    bigVersion=`echo $version | cut -d "." -f1`
    if [[ $bigVersion > "10" ]]; then
        echo "[11.x.x]execute_uninstall_icore_app" 2>&1 >>$DBGLOG
        execute_uninstall_icore_app
        return
    fi
	version=${version#*.}
	version=${version%.*}
	if [[ $version > "14" ]]; then
		echo "execute_uninstall_icore_app" 2>&1 >>$DBGLOG
		execute_uninstall_icore_app
	fi
}

execute_uninstall_icore_app()
{
    osascript <<EOD
        tell application "Finder"
            set sourceFolder to POSIX file "/Applications/TrendMicro.localized/AFMAgent.app/Contents/Resources/iCoreService.app"
            delete sourceFolder
        end tell
EOD
	osascript <<EOD
        tell application "Finder"
            set sourceFolder to POSIX file "/Applications/TrendMicro.localized/iTIS.app/Contents/Resources/iCoreService.app"
            delete sourceFolder
        end tell
EOD
    echo "uninstall iCoreService.app" 2>&1 >>$DBGLOG
}

uninstall_app()
{
	USERLIST="$(find /Users -maxdepth 1 -type d | grep -v "^/Users$" | grep -v "Shared" | grep -v "Guest" | grep -v "Deleted*" | sed "s/\/Users\///")"
	for CUR_USER in $USERLIST ; do 
    	rm -rf "/Users/${CUR_USER}/Library/Application Support/iTISToolpage/" 2>/dev/null >/dev/null
	done

	forceRun_dmr
	tagpercent "5"

	stop_Kext_Services
	tagpercent "7"

	uninstall_itistoolbar
	tagpercent "18"

	for i in $UI_FILES; do
		remove_file -Rf "$TM_DIR/$i"
	done

	for i in $UIAPP_FILES; do
		remove_file -Rf "/Applications/$APPLICATION_FOLDER/$i"
	done
	app_is_empty /Applications/$APPLICATION_FOLDER/
	if [ $? -eq 0 ]; then
		remove_file -Rf "/Applications/$APPLICATION_FOLDER"
	fi

	tagpercent "24"

	#remove all the launchd plist
	rm -Rf /Library/LaunchAgents/com.trendmicro.itis.*
	rm -Rf /Library/PrivilegedHelperTools/com.trendmicro.AFM.HelperTool

	#workaround for 10.5
	killall UIMgmt 2>/dev/null >/dev/null

	tagpercent "29"


	uninstall_dca
	tagpercent "30"

    uninstall_gaagent
    tagpercent "31"

	uninstall_dmr
	tagpercent "32"

	uninstall_pum
	tagpercent "33"

	USERS_DIR=/Users
	for UDIR in ${USERS_DIR}/* ; do
		TARGET_HOME="${UDIR}"
		for file in $UIAPP_CONF_FILES $USER_LOG_FILES $UNINSTALLER_PLIST; do
			remove_file -Rf "$TARGET_HOME/$file"
		done

		#clean user trash folder
		find "$TARGET_HOME/.Trash" -name "iTIS.app" -or -name "AFMAgent.app" -or -name "SupportTool.app" -or -name "TMMacUninstaller.app" -or -name "AirSupportDownloader.app" | xargs rm -rf

		for file in $WEB_KIT_CACHES; do
			CACHE="$TARGET_HOME/Library/Caches/$file"
			if [ -e "$CACHE" ]; then
				remove_file -Rf "$CACHE"
			fi
		done
	done

	tagpercent "34"

	for i in $FWK_DIRS ; do
		remove_file -Rf "$i"
	done

	tagpercent "40"

	for i in ${APP_RECEIPTS} ; do
		remove_file -Rf "/Library/Receipts/$i.pkg"
	done

	for pkg in /Library/Receipts/*Postflight.pkg ; do
		echo "Finding Postflight receipt in /Lirbary/Receipts" >> $DBGLOG
		if [ -d "$pkg" ]; then
			get_valueByKey "${pkg}$DEFAULT_INFO_PLIST" CFBundleIdentifier
			if [ -z "$kMDItemValue" ]; then
				get_valueByKey "$pkg" kMDItemCFBundleIdentifier
			fi
			# Match prefix of iTIS pkg bundle identifier
			if [[ $kMDItemValue == ${ITIS_PKG_BUNDLE_ID_PREFIX}* ]]; then
				echo "Found $kMDItemValue ($pkg)" >> $DBGLOG
				remove_file -Rf "$pkg"
			fi
		fi
	done
	remove_receipt_specified_prefix "${ITIS_PKG_BUNDLE_ID_PREFIX}*"
	remove_file -Rf $CHKDAT

	tagpercent "45"

	#remove_file -Rf $VAR_LOG_FILES
	for i in $VAR_LOG_FILES; do
		remove_file -Rf "$VAR_LOG_FOLDER/$i"
	done

	array=`echo $(ls -A $VAR_LOG_FOLDER/)`
	for i in $array; do
		file_is_iTISPlugin $i
		if [ $? -eq 1 ]; then
			remove_file -Rf $VAR_LOG_FOLDER/$i
		fi
	done

	dir_is_empty $VAR_LOG_FOLDER/
	if [ $? -eq 0 ]; then
		remove_file -Rf $VAR_LOG_FOLDER
	fi

	return 0
}

rm_core_receipts()
{
	# before 1022 build
	RLST=""
	RLST="${RLST} aucfg"
	RLST="${RLST} aupatch"
	RLST="${RLST} comtrendmicrotmccautostart"
	RLST="${RLST} keredirect"
	RLST="${RLST} libpatch"
	RLST="${RLST} libtmactupdate"
	RLST="${RLST} libtmcccorecommon"
	RLST="${RLST} libtmcccoredataclib"
	RLST="${RLST} libtmcccorefs"
	RLST="${RLST} libtmcccoreupdate"
	RLST="${RLST} libtmccmacclientlib"
	RLST="${RLST} libtmccmachelper"
	RLST="${RLST} libtmccproxy"
	RLST="${RLST} libtmufeng"
	RLST="${RLST} libvsapi"
	RLST="${RLST} lptvpn"
	RLST="${RLST} ssaptn"
	RLST="${RLST} tmccfshook104"
	RLST="${RLST} tmccfshook105"
	RLST="${RLST} tmccmac"
	RLST="${RLST} tmccmaclog"
	RLST="${RLST} tmccmainservice"
	RLST="${RLST} urlfcat"
	RLST="${RLST} urlferr"
	RLST="${RLST} urlfud"
	RLST="${RLST} urlfwtp"

	# new version after 1022 build
	RLST_CURR="autostart core corekext"
	for i in ${RLST} ${RLST_CURR} ; do
		remove_file -Rf "/Library/Receipts/$i.pkg"
	done

	remove_receipt_specified_prefix "${CORE_PKG_BUNDLE_ID_PREFIX}*"
	return 0
}

LaunchdDir="/Library/LaunchDaemons"

coreServices=(
	"com.trendmicro.icore.main"
	"com.trendmicro.icore.av"
	"com.trendmicro.icore.wp"
    "com.trendmicro.icore.misc"
	"com.trendmicro.itis.plugin"
	"com.trendmicro.AFM.HelperTool"
)

# stop iCoreservice
stopiCore()
{
	for item in ${coreServices[@]}; do
		launchctl stop "${item}"
		launchctl unload "${LaunchdDir}/${item}.plist"
	done

	PSLIST=$(ps A -o pid,command | grep "^\(\/Library\/.*\/TmccMac/\)\?\(iCoreService\|UpdateUtility\)$" | awk '{print $1}')
	if [ ! -z "$PSLIST" ]; then
		for pid in $PSLIST; do
		kill -9 $pid
	done
	fi

	killall -9 iCoreService 2>/dev/null >/dev/null
	killall -9 iCorePluginMgr 2>/dev/null >/dev/null
}


stop_srv()
{
	# entry existed
	#if [ -e /Library/StartupItems/iCoreService ]; then
	#    /sbin/SystemStarter -D stop iCoreService 2>>$DBGLOG >>$DBGLOG
	#elif [ -e /Library/StartupItems/TmccCore ]; then
	#    /sbin/SystemStarter -D stop TmccCore 2>>$DBGLOG >>$DBGLOG
	#fi
	stopiCore

	KEXTLIST=$(kextstat | grep trendmicro | awk '{print $6}')
	if [ ! -z "$KEXTLIST" ]; then
		for kext in $KEXTLIST; do
			kextunload -b $kext
		done
	fi
	return 0
}

stop_Kext_Services()
{
	launchctl stop com.trendmicro.itis.kext
	launchctl unload /Library/LaunchDaemons/com.trendmicro.itis.kext.plist
	
	launchctl unload /Library/Application\ Support/TrendMicro/common/conf/TmStartDecompress.plist
}

uninstall_core()
{
	stop_srv

	tagpercent "60"
	for i in $CORE_FILES ; do
		remove_file -Rf "${TM_DIR}/$i";
	done

	tagpercent "80"
	for i in $SYSCORE_FILES ; do
		remove_file -Rf "$i";
	done

	# Applican Support Root
	rm -Rf /var/tmp/port.iCore.*
	remove_file -Rf /Library/StartupItems/iCoreService
	remove_file -Rf /System/Library/TrendMicro

	tagpercent "90"

	dir_is_empty "${TM_DIR}"
	if [ $? -eq 0 ]; then
		remove_file -Rf "${TM_DIR}"
	fi

	#remove iCore and iTis launchd plists
	rm -Rf /Library/LaunchDaemons/com.trendmicro.icore.*
	rm -Rf /Library/LaunchDaemons/com.trendmicro.itis.*
	rm -Rf /Library/LaunchDaemons/com.trendmicro.AFM.HelperTool.plist

	# Remove receipts
	rm_core_receipts
	return 0
}

remove_history_files()
{
	rm -rf /usr/local/bin/TMPluginPlistTool
}

remove_temp_files()
{
	rm -rf /tmp/TMSS-EMAIL.plist
	rm -rf /tmp/TMSS-LOCALE.plist
	rm -rf /tmp/TMSS-SN.txt
    rm -rf /Users/Shared/TMSS-SN.txt
	rm -rf /tmp/TrendMicro
}

uninstall_itistoolbar()
{
	ITISTOOLBAR="/Library/Application Support/TrendMicro/TmToolbar"
	sh "$ITISTOOLBAR/Setup/toolbar_installer.sh" -u safari 2>&1 >> $DBGLOG
	sh "$ITISTOOLBAR/Setup/toolbar_installer.sh" -u chrome 2>&1 >> $DBGLOG
	sh "$ITISTOOLBAR/Setup/toolbar_installer.sh" -u firefox 2>&1 >> $DBGLOG
	#"$ITISTOOLBAR/Setup/toolbar_installer.sh" -u wtp_workaround
}

clean_old_itis_pkgs()
{
	if [ -e "/Library/Receipts/db/a.receiptdb" ]; then
		python -c "import sqlite3;conn = sqlite3.connect('/Library/Receipts/db/a.receiptdb');c = conn.cursor();sql_cmd = 'DELETE FROM oldpkgs WHERE pkgid LIKE \'com.trendmicro.iTIS.installer.%\'';sql_cmd2 = 'DELETE FROM pkgs WHERE pkgid LIKE \'com.trendmicro.iTIS.installer.%\'';c.execute(sql_cmd);c.execute(sql_cmd2);conn.commit();c.close()"
	fi
	rm -rf "/Library/Receipts/boms/$ITIS_PKG_BUNDLE_ID_PREFIX"*
}

uninstall_dca()
{
	rm -rf "$DCA_PLIST" 2>/dev/null >/dev/null
	rm -rf "$TM_DIR/DCA" 2>/dev/null >/dev/null
	rm -rf "/tmp/.dca" 2>/dev/null >/dev/null

	USERLIST="$(find /Users -maxdepth 1 -type d | grep -v "^/Users$" | grep -v "Shared" | grep -v "Guest" | grep -v "Deleted*" | sed "s/\/Users\///")"
	for CUR_USER in $USERLIST ; do
		sudo -u "$CUR_USER" launchctl unload "$DCA_JOB" 2>/dev/null >/dev/null

		echo "removing /Users/${CUR_USER}/Library/Caches/DCACache" 2>&1 >> $DBGLOG
		rm -rf "/Users/${CUR_USER}/Library/Caches/DCACache" 2>/dev/null >/dev/null

		echo "removing /Users/${CUR_USER}/Library/Preferences/com.trendmicro.DCAManager.plist" 2>&1 >> $DBGLOG
		rm -f "/Users/${CUR_USER}/Library/Preferences/com.trendmicro.DCAManager.plist" 2>/dev/null >/dev/null

	done
}

uninstall_gaagent()
{
#launchctl remove "$GAAGENT_PLIST" 2>/dev/null >/dev/null
ps -ww -A -opid,user,command | \
perl -nae 'if($F[2] =~ /\bloginwindow\b/) { system(
qq( su $F[1] -c "launchctl remove '$GAAGENT_JOB'"))
}'
rm -rf "$GAAGENT_PLIST" 2>/dev/null >/dev/null
rm -rf "$TM_DIR/GAAgent" 2>/dev/null >/dev/null
}

forceRun_dmr()
{
	echo "start run forceRun_dmr" 2>&1 >> $DBGLOG
	cd /Library/Application\ Support/TrendMicro/DMR/DMRManager.app/Contents/MacOS
	sudo -u "${LOGNAME}" ./DMRManager -f -t n
}

uninstall_dmr()
{
	rm -rf "$DMR_PLIST" 2>/dev/null >/dev/null
	rm -rf "$TM_DIR/DMR" 2>/dev/null >/dev/null
	rm -rf "/tmp/.dmr" 2>/dev/null >/dev/null

	USERLIST="$(find /Users -maxdepth 1 -type d | grep -v "^/Users$" | grep -v "Shared" | grep -v "Guest" | grep -v "Deleted*" | sed "s/\/Users\///")"
	for CUR_USER in $USERLIST ; do
		sudo -u "$CUR_USER" launchctl unload "$DMR_JOB" 2>/dev/null >/dev/null

		echo "removing /Users/${CUR_USER}/Library/Preferences/com.trendmicro.DMRManager.plist" 2>&1 >> $DBGLOG
		rm -f "/Users/${CUR_USER}/Library/Preferences/com.trendmicro.DMRManager.plist" 2>/dev/null >/dev/null
	done
}

uninstall_pum()
{
	rm -rf "$PUM_PLIST" 2>/dev/null >/dev/null
	rm -rf "$TM_DIR/PUM" 2>/dev/null >/dev/null

	USERLIST="$(find /Users -maxdepth 1 -type d | grep -v "^/Users$" | grep -v "Shared" | grep -v "Guest" | grep -v "Deleted*" | sed "s/\/Users\///")"
	for CUR_USER in $USERLIST ; do
		sudo -u "$CUR_USER" launchctl unload "$PUM_JOB" 2>/dev/null >/dev/null
	done
}


uninstall_pyratingserver()
{
	launchctl unload "$PYRATING_SERVER_JOB" 2>/dev/null >/dev/null
	rm -rf "$PYRATING_SERVER_TARGET" 2>/dev/null >/dev/null
}

remove_Dock_icons()
{
	AppName1="iTIS.app"
	AppName2="SupportTool.app"
	AppName3="TMMacUninstaller.app"
	AppName4="AirSupportDownloader.app"
	AppName5="AFMAgent.app"

	pathToPlist="/usr/libexec/PlistBuddy"

	allUsers=`find /Users -maxdepth 1 -type d| grep -v "^/Users$" |grep -v "Shared" | grep -v "Deleted*" | grep -v "Guest" | sed "s/\/Users\///"`

	for currentUser in $allUsers ; do
   		echo $currentUser
    	line=`$pathToPlist -c "print persistent-apps" /Users/$currentUser/Library/Preferences/com.apple.dock.plist`
    	lineNum=`echo $line | awk -F'GUID' '{print NF-1}'`
    	for (( x=0;x<lineNum;x+=1 )) ; do
        	currentApp=`$pathToPlist -c "print persistent-apps:$x" /Users/$currentUser/Library/Preferences/com.apple.dock.plist`
        	app=`echo "$currentApp" | egrep "${AppName1}|${AppName2}|${AppName3}|${AppName4}|${AppName5}"`
        	if [ "$?" -eq 0 ]; then
            	`$pathToPlist -c "delete persistent-apps:$x" /Users/$currentUser/Library/Preferences/com.apple.dock.plist`
            	x=`expr $x - 1`
            	lineNum=`expr $lineNum - 1`
        	fi
    	done

    	line=`$pathToPlist -c "print recent-apps" /Users/$currentUser/Library/Preferences/com.apple.dock.plist`
    	lineNum=`echo $line | awk -F'GUID' '{print NF-1}'`
    	for (( x=0;x<lineNum;x+=1 )); do
        	currentApp=`$pathToPlist -c "print recent-apps:$x" /Users/$currentUser/Library/Preferences/com.apple.dock.plist`
        	app=`echo "$currentApp" | egrep "${AppName1}|${AppName2}|${AppName3}|${AppName4}|${AppName5}"`
        	if [ "$?" -eq 0 ]; then
        		`$pathToPlist -c "delete recent-apps:$x" /Users/$currentUser/Library/Preferences/com.apple.dock.plist`
        		x=`expr $x - 1`
        		lineNum=`expr $lineNum - 1`
    		fi
    	done
	done
	return 0
}

remove_Dock_icons_new()
{
	USERLIST="$(find /Users -maxdepth 1 -type d | grep -v "^/Users$" | grep -v "Shared" | grep -v "Guest" | grep -v "Deleted*" | sed "s/\/Users\///")"
	for CUR_USER in $USERLIST ; do
		path=`echo $(sudo -u $CUR_USER getconf DARWIN_USER_DIR)`
		echo $path 2>&1 >> $DBGLOG
		sudo -u $CUR_USER sqlite3 $(find $path -name com.apple.dock.launchpad)/db/db "DELETE FROM apps WHERE bundleid like 'com.trendmicro.iTIS%'"
		sudo -u $CUR_USER sqlite3 $(find $path -name com.apple.dock.launchpad)/db/db "DELETE FROM apps WHERE bundleid like 'com.trendmicro.AFMAgent%'"
	done

	return 0
}

uninstall_all()
{
	lock
	unload_app
	uninstall_icore_app
	backup_corridor
	uninstall_app
	#uninstall_pyratingserver
	uninstall_core
	ret1=$?
	tagpercent "95"
	ret2=$?
	uninstall_itis10
	remove_history_files
	remove_temp_files
	clean_old_itis_pkgs
	remove_Dock_icons
	remove_Dock_icons_new
	unlock
	return $((ret1 | ret2))
}

# main
trap trap_hook 2 15

RET=0
if [ -z "$1" ]; then
	OPT="all"
else
	OPT="$1"
fi

mkdir -p $TMP_ITIS_INFO_DIR
chmod -R 777 $TMP_ITIS_INFO_DIR

initpercent "0"
chmod 777 "$TMP_UNINSTALL_INFO_PLIST"

case "$OPT" in
app)
uninstall_app;
RET=$?
;;

core)
uninstall_core;
RET=$?
;;

itis10)
uninstall_itis10;
RET=$?
;;

all)
uninstall_all;
RET=$?
;;

*)
usage;
RET=-1
;;
esac

tagpercent "100"

exit $RET;
